variables:
    CONAN_NON_INTERACTIVE: 1
    CONAN_REFERENCE: "boards/0.0.0"
    CONAN_CHANNEL: "testing"

stages:
  - install
  - build
  - test
  - deploy

.setup: &setup
  before_script:
    - conan remote add just-a-framework ${CONAN_UPLOAD}
    - conan user -r just-a-framework
    - conan config set storage.path=$(pwd)/conan_storage

install:clang:
  image: conanio/clang9
  stage: install
  <<: *setup
  script:
    - conan install . --install-folder build --build missing
  artifacts:
    paths:
      - build
      - conan_storage
    expire_in: 20 minutes

build:clang:
  image: conanio/clang9
  stage: build
  dependencies:
    - install:clang
  <<: *setup
  script:
      - conan build . --build-folder build
  artifacts:
    paths:
      - build
      - conan_storage
    expire_in: 20 minutes

test:clang:
  image: conanio/clang9
  stage: test
  dependencies:
    - build:clang
  <<: *setup
  script:
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - conan test test ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} --build missing
  artifacts:
    paths:
      - build
      - conan_storage
    expire_in: 20 minutes
  
deploy-testing:clang:
  image: conanio/clang9
  stage: deploy
  dependencies:
    - test:clang
  only:
    - master
  <<: *setup
  script:
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - conan upload ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} -r just-a-framework
  artifacts:
    paths:
      - build/package
    expire_in: 20 minutes
  
deploy-stable:clang:
  image: conanio/clang9
  stage: deploy
  dependencies:
    - test:clang
  only:
    - tags
  variables:
    CONAN_CHANNEL: "stable"
  <<: *setup
  script:
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - conan upload ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} -r just-a-framework
  artifacts:
    paths:
      - build/package
    expire_in: 20 minutes
